/** BaseHechos.java
   Implementa la base de hechos de un sistema experto que juega al
   conecta 4, es decir, la forma de representar el tablero.
   @author Alberto Alonso Ruibal
*/

class BaseHechos {

	// Constantes
	static int iFICHA_BLANCA = 1;
	static int iFICHA_NEGRA = -1;

	// Variables que representan el estado de la base de hechos
	int iTablero[][];
	boolean bTurno;

	/**
	   Construye una base de hechos con el estado inicial
	   (que es un tablero vaco)
	 */
	BaseHechos() {
		iTablero = new int[7][6];
		bTurno = true;
	}

	/**
	   Construye una base de hechos copiando el estado de otra
	   (un tablero copia de otro)
	 */
	BaseHechos(BaseHechos oBaseHechos) {
		iTablero = new int[7][6];
		bTurno = true;
		copia(oBaseHechos);
	}

	/**
	   Copia el contenido de otra base de hechos
	 */
	void copia(BaseHechos oBaseHechosOrigen) {
		int i, j;
		for (i = 0; i < 7; i++)
			for (j = 0; j < 6; j++)
				iTablero[i][j] = oBaseHechosOrigen.iTablero[i][j];
		bTurno = oBaseHechosOrigen.bTurno;
   	}

	/**
	   Imprime por la salida estndar el estado de la base de hechos
	   (el tablero actual)
	*/
	void imprime() {
		int i, j;
		System.out.println();
		for (j = 5; j >= 0; j--) {
			System.out.print("    ");
			for (i = 0; i < 7; i++) {
				switch (iTablero[i][j]) {
				case 0 : System.out.print(" .");
					break;
				case 1 : System.out.print(" O");
					break;
				case -1 : System.out.print(" X");
					break;
				}
			}
			System.out.println();
		}
		System.out.println("     0 1 2 3 4 5 6");
	}
}
