/** Conecta4.java
	Applet que Juega al Conecta-4.
*/

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class Conecta4 extends Applet implements ActionListener, Runnable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	int i;
	MotorInferencias oMotorInferencias;
	Panel oPanelTablero, oPanelControl, oPanelGlobal;
	Label oMensaje;
	Thread oTarea;
	Integer iMovimiento;

	public void init() {
		int i;
		Button oBoton;
		GraficoFicha oGraficoFicha;

		oMotorInferencias = new MotorInferencias();

		// Crea los graficos
		oPanelControl = new Panel();
		oPanelControl.setLayout(new FlowLayout());
		oBoton = new Button("Reiniciar");
		oBoton.setActionCommand("r");
		oBoton.addActionListener(this);
		oPanelControl.add(oBoton);

		oBoton = new Button("Cambiar");
		oBoton.setActionCommand("c");
		oBoton.addActionListener(this);
		oPanelControl.add(oBoton);

		oMensaje = new Label("(c) 2k Alberto Alonso Ruibal");
		oPanelControl.add(oMensaje);

		oPanelTablero = new Panel();
		oPanelTablero.setLayout(new GridLayout(7,7));
		for (i = 0; i < 7; i++) {
			oBoton = new Button(String.valueOf((char)('a'+ i)));
			oBoton.setActionCommand(Integer.toString(i));
			oBoton.addActionListener(this);
			oPanelTablero.add(oBoton);
		}
		for (i = 0; i < 7*6; i++) {
			oGraficoFicha = new GraficoFicha();
			oPanelTablero.add(oGraficoFicha);
		}

		oPanelGlobal = new Panel();
		oPanelGlobal.setBackground(Color.LIGHT_GRAY);
		oPanelGlobal.setLayout(new BorderLayout());
		oPanelGlobal.add("North", oPanelControl);
		oPanelGlobal.add("Center", oPanelTablero);
		add(oPanelGlobal);
		redibujaTablero();
	}

	public void start() {
	}

	public void stop() {
	}

	public void paint(Graphics oG) {
	}

	/**
	   Actualiza las posiciones del tablero en pantalla con el
	   teblero sobre el que calculamos.
	*/
	public void redibujaTablero() {
		int i, j;
		GraficoFicha oGraficoFicha;

		for (j = 0; j < 6; j++) 
			for (i = 0; i < 7; i++) {
				oGraficoFicha = (GraficoFicha)
					oPanelTablero.getComponent(42 - 7*j + i);
				oGraficoFicha.cambia(
					oMotorInferencias.oBaseHechos.iTablero[i][j]);
			}
	}

	/**
	   Tarea que se ejecuta desde que el jugador humano mueve
	   hasta que el ordenador termina de pensar y mueve.
	*/
	public void run() {
		oMensaje.setText("Pensando...");		
		oMotorInferencias.aplicaOperacion(new Operacion(iMovimiento), true);
		redibujaTablero();
		oMotorInferencias.juega();
		redibujaTablero();
		switch(oMotorInferencias.oBaseConocimientos.hay4enRaya()) {
		case 0 : oMensaje.setText("Tu juegas..."); break;
		case 1 : oMensaje.setText("Ganaron las rojas"); break;
		case -1: oMensaje.setText("Ganaron las amarillas"); break;
		}
		oTarea = null;
	}

	/**
	   Gestor de Eventos
	 */
	public void actionPerformed(ActionEvent oAE) {
		if (oAE.getActionCommand() == "r") {
			// Para la tarea si no estaba parada
			if (oTarea != null) {
				oTarea = null;
			}
			oMotorInferencias = new MotorInferencias();
			redibujaTablero();
			oMensaje.setText("(c) 2k Alberto Alonso Ruibal");
		} else if (oAE.getActionCommand() == "c") {
			iMovimiento = new Integer(-1);
			if (oTarea == null) {
				oTarea = new Thread(this);
				oTarea.start();
			}
		} else {
			iMovimiento = new Integer(oAE.getActionCommand());
			if (oTarea == null) {
				oTarea = new Thread(this);
				oTarea.start();
			}
		}
	}
}
