import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;

/**
 * Implementa un canvas con una ficha dibujada
 * @author Alberto Alonso Ruibal
 */

class GraficoFicha extends Canvas
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/** Ficha que contiene este grafico (0=vacio, 1=blanca, -1=negra) */
	int iFicha;
	int iTamanhoCelda, iTamanhoFicha;

    GraficoFicha()
    {
		super();
		iFicha = 0;
		iTamanhoCelda = 35;
		iTamanhoFicha = 25;
		setSize(iTamanhoCelda, iTamanhoCelda);
    }
    /** 
		Redibuja la ficha
	*/
    public void paint(Graphics oG)
    {
		int k = (iTamanhoCelda - iTamanhoFicha)/2;
		switch(iFicha) {
	    case 0:
			oG.setColor(Color.black);
			oG.fillOval(k, k, iTamanhoCelda - k, iTamanhoCelda - k);
			break;
		case 1:
			oG.setColor(Color.red);
			oG.fillOval(k, k, iTamanhoCelda - k, iTamanhoCelda - k);
			break;
		case -1:
			oG.setColor(Color.yellow);
			oG.fillOval(k, k, iTamanhoCelda - k, iTamanhoCelda - k);
			break;
		}
    }

	/**
	   Cambia el contenido del grafico
	*/
	public void cambia(int iNuevaFicha) {
		if (iFicha != iNuevaFicha) {
			iFicha = iNuevaFicha;
			repaint();
		}
	}
}



